!= Module StorePotTemp
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: storepottemp.f90,v 1.7 2011-04-05 14:46:54 sugiyama Exp $ 
! Tag Name::  $Name: arare4-20110906 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!̤˴ؤѻͤݴɤ뤿ѿ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module StorePotTemp
  !
  !̤˴ؤѻͤݴɤ뤿ѿ⥸塼.
  !

  !⥸塼ɤ߹
  use gridset, only:   DimXMin,     & ! x β
    &                  DimXMax,     & ! x ξ
    &                  DimZMin,     & ! z β
    &                  DimZMax,     & ! z ξ
    &                  SpcNum,      & ! number of species
    &                  RegXMin,     & ! x ʪΰβ
    &                  RegXMax        ! x ʪΰξ
  use TimeSet, only:   TimeDisp,    & ! ϻֳִ
    &                  DelTimeShort,& ! û֥ƥå
    &                  DelTimeLong    ! Ĺ֥ƥå

  !ۤηػ
  implicit none

  !°λ
  private

  !
  public StorePotTemp_Init, StorePotTempMeanX, StorePotTempClean
  public z_Adv,  z_Turb, z_Disp, z_Diff, z_Rad, &
    &    z_Cond, z_Flux, z_Damp, za_Cond2, z_Cond3
  public xz_Adv,  xz_Turb, xz_Disp, xz_Diff, xz_Rad, &
    &    xz_Cond, xz_Flux, xz_Damp
  public StorePotTempAdv,  StorePotTempTurb, StorePotTempDisp, StorePotTempDiff, StorePotTempRad, &
    &    StorePotTempCond, StorePotTempFlux, StorePotTempDamp, StorePotTempCond2, StorePotTempCond3

  !ѿ
  real(8), allocatable :: z_Adv(:)
  real(8), allocatable :: z_Turb(:)
  real(8), allocatable :: z_Disp(:)
  real(8), allocatable :: z_Diff(:)
  real(8), allocatable :: z_Rad(:)
  real(8), allocatable :: z_Damp(:)
  real(8), allocatable :: z_Cond(:)
  real(8), allocatable :: za_Cond2(:,:)
  real(8), allocatable :: z_Cond3(:)
  real(8), allocatable :: z_Flux(:)
  real(8), allocatable :: xz_Adv(:,:)
  real(8), allocatable :: xz_Turb(:,:)
  real(8), allocatable :: xz_Disp(:,:)
  real(8), allocatable :: xz_Diff(:,:)
  real(8), allocatable :: xz_Rad(:,:)
  real(8), allocatable :: xz_Damp(:,:)
  real(8), allocatable :: xz_Cond(:,:)
  real(8), allocatable :: xza_Cond2(:,:,:)
  real(8), allocatable :: xz_Cond3(:,:)
  real(8), allocatable :: xz_Flux(:,:)
  integer, save        :: CalNumAdv = 0
  integer, save        :: CalNumTurb = 0
  integer, save        :: CalNumDiff = 0
  integer, save        :: CalNumDisp = 0
  integer, save        :: CalNumRad = 0
  integer, save        :: CalNumDamp = 0
  integer, save        :: CalNumCond = 0
  integer, save        :: CalNumCond2 = 0
  integer, save        :: CalNumCond3 = 0
  integer, save        :: CalNumFlux = 0

  !save °
  save xz_Adv,  xz_Turb, xz_Disp, xz_Diff, xz_Rad, &
    &  xz_Cond, xza_Cond2, xz_Cond3, xz_Flux, xz_Damp
  save z_Adv,  z_Turb, z_Disp, z_Diff, z_Rad, &
    &  z_Cond, za_Cond2, z_Cond3, z_Flux, z_Damp

contains

  subroutine StorePotTemp_Init()

    !롼
    allocate(     &
      & z_Adv(DimZMin:DimZMax),  & 
      & z_Turb(DimZMin:DimZMax), &
      & z_Disp(DimZMin:DimZMax), &
      & z_Diff(DimZMin:DimZMax), &
      & z_Rad(DimZMin:DimZMax),  &
      & z_Damp(DimZMin:DimZMax), &
      & z_Cond(DimZMin:DimZMax), &
      & za_Cond2(DimZMin:DimZMax, 1:SpcNum), &
      & z_Cond3(DimZMin:DimZMax), &
      & z_Flux(DimZMin:DimZMax), &
      & xz_Adv(DimXMin:DimXMax, DimZMin:DimZMax),  & 
      & xz_Turb(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_Disp(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_Diff(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_Rad(DimXMin:DimXMax, DimZMin:DimZMax),  &
      & xz_Damp(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_Cond(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xza_Cond2(DimXMin:DimXMax, DimZMin:DimZMax, 1:SpcNum), &
      & xz_Cond3(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_Flux(DimXMin:DimXMax, DimZMin:DimZMax)  &
      &  )

    call StorePotTempClean

  end subroutine StorePotTemp_Init


  subroutine StorePotTempClean( )
    !ݴɤͤΥꥢ
    
    z_Adv  = 0.0d0
    z_Turb = 0.0d0
    z_Diff = 0.0d0
    z_Disp = 0.0d0
    z_Rad  = 0.0d0
    z_Damp = 0.0d0
    z_Cond = 0.0d0
    za_Cond2 = 0.0d0
    z_Cond3 = 0.0d0
    z_Flux = 0.0d0

    xz_Adv  = 0.0d0
    xz_Turb = 0.0d0
    xz_Diff = 0.0d0
    xz_Disp = 0.0d0
    xz_Rad  = 0.0d0
    xz_Damp = 0.0d0
    xz_Cond = 0.0d0
    xza_Cond2 = 0.0d0
    xz_Cond3 = 0.0d0
    xz_Flux = 0.0d0

!    write(*,*) "CalNumAdv  ", CalNumAdv
!    write(*,*) "CalNumCond ", CalNumCond
!    write(*,*) "CalNumRad  ", CalNumRad
!    write(*,*) "CalNumFlux ", CalNumFlux

    CalNumAdv  = 0
    CalNumTurb = 0
    CalNumDiff = 0
    CalNumDisp = 0
    CalNumRad  = 0
    CalNumDamp = 0
    CalNumCond = 0
    CalNumCond2= 0
    CalNumCond3= 0
    CalNumFlux = 0
  end subroutine StorePotTempClean


  subroutine StorePotTempMeanX( )

    real(8):: CalNum

    CalNum = TimeDisp / DelTimeLong

    z_Adv  = a_MeanX_aa( xz_Adv )   / CalNum
    z_Turb = a_MeanX_aa( xz_Turb )  / CalNum
    z_Diff = a_MeanX_aa( xz_Diff )  / CalNum
    z_Disp = a_MeanX_aa( xz_Disp )  / CalNum
    z_Rad  = a_MeanX_aa( xz_Rad )  / CalNum
    z_Damp = a_MeanX_aa( xz_Damp )  / CalNum
    z_Cond = a_MeanX_aa( xz_Cond )  / CalNum
    za_Cond2 = aa_MeanX_aaa( xza_Cond2 )  / CalNum
    z_Cond3 = a_MeanX_aa( xz_Cond3 )  / CalNum
    z_Flux = a_MeanX_aa( xz_Flux )  / CalNum

  end subroutine StorePotTempMeanX


  subroutine StorePotTempAdv( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2  = xz_Adv + Work
    xz_Adv = Work2

    CalNumAdv = CalNumAdv + 1

  end subroutine StorePotTempAdv


  subroutine StorePotTempTurb( Work )
    !ήݴ

    implicit none

    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_Turb + Work
    xz_Turb = Work2

    CalNumTurb = CalNumTurb + 1

  end subroutine StorePotTempTurb


  subroutine StorePotTempDiff( Work )
    !ͳȻݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_Diff + Work
    xz_Diff = Work2

    CalNumDiff = CalNumDiff + 1

  end subroutine StorePotTempDiff


  subroutine StorePotTempDisp( Work )
    !Ǯݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_Disp + Work
    xz_Disp = Work2

    CalNumDisp = CalNumDisp + 1

  end subroutine StorePotTempDisp


  subroutine StorePotTempRad( Work )
    !ѹݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2  = xz_Rad + Work
    xz_Rad = Work2

    CalNumRad = CalNumRad + 1

  end subroutine StorePotTempRad


  subroutine StorePotTempDamp( Work )
    !ԥ󥰹ݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_Damp + Work
    xz_Damp = Work2

    CalNumDamp = CalNumDamp + 1

  end subroutine StorePotTempDamp


  subroutine StorePotTempCond( Work )
    !ǮȯǮݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_Cond + Work
    xz_Cond = Work2
    
    CalNumCond = CalNumCond + 1

  end subroutine StorePotTempCond

  subroutine StorePotTempCond2( Work, ID )
    !ǮȯǮݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax, 1:SpcNum)
    integer              :: ID

    Work2(:,:,ID)    = xza_Cond2(:,:,ID) +  Work 
    xza_Cond2(:,:,ID) = Work2(:,:,ID)

    CalNumCond2 = CalNumCond2 + 1

  end subroutine StorePotTempCond2

  subroutine StorePotTempCond3( Work )
    !ǮȯǮݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_Cond3 + Work 
    xz_Cond3 = Work2

    CalNumCond3 = CalNumCond3 + 1

  end subroutine StorePotTempCond3


  subroutine StorePotTempFlux( Work )
    !ɽ̥եåݴ

    implicit none
    
    real(8), intent(in)  :: Work(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)              :: Work2(DimXMin:DimXMax, DimZMin:DimZMax)

    Work2   = xz_Flux + Work
    xz_Flux = Work2

    CalNumFlux = CalNumFlux + 1

  end subroutine StorePotTempFlux


  function a_MeanX_aa( var ) 
    !
    ! ʿʿͤη׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: var(DimXMin:DimXMax, DimZMin:DimZMax)
                                     !ʿѱ黻оݤȤʤѿ
    real(8)              :: a_MeanX_aa(DimZMin:DimZMax)
                                     !ʿʿ

    a_MeanX_aa = sum( var(RegXMin+1:RegXMax, :), 1 ) &
      &           / real(RegXMax - RegXMin, 8) 

  end function a_MeanX_aa

  function aa_MeanX_aaa( var ) 
    !
    ! ʿʿͤη׻
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: var(DimXMin:DimXMax, DimZMin:DimZMax, 1:SpcNum)
                                     !ʿѱ黻оݤȤʤѿ
    real(8)              :: aa_MeanX_aaa(DimZMin:DimZMax, 1:SpcNum)
                                     !ʿʿ

    aa_MeanX_aaa = sum( var(RegXMin+1:RegXMax, :, :), 1 ) &
      &           / real(RegXMax - RegXMin, 8) 

  end function aa_MeanX_aaa
  
end module StorePotTemp
